﻿#region MIT License
/*

Copyright (C) 2011 by Timothy A. Barela

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/
#endregion

using System;
using Sharpener;

namespace TestExe
{
	public class InlineMethods
	{
		[ForceInline(RemoveFromAssembly=false)]
		public static void SimpleInlineMethod()
		{
			Console.WriteLine("This is a SimpleInlineMethod.");
			Console.WriteLine(43 + 58);
		}

		[ForceInline(RemoveFromAssembly=false)]
		public static void ComplexInlineMethod()
		{
			DateTime dt;
			int counter;

			dt = DateTime.Now;

			Console.WriteLine("This is a ComplexInlineMethod called at {0}.", dt.ToString());

			counter = dt.Hour * 2;

			Console.WriteLine("Hour * 2 = {0}", counter.ToString());
		}

		[ForceInline(RemoveFromAssembly=false)]
		public static int ReturnTypeInlineMethod()
		{
			return 16;
		}

		[ForceInline]
		public void SimpleInstanceInlineMethod()
		{
			Console.WriteLine("This is a SimpleInstanceInlineMethod.");
		}

		[ForceInline]
		public static void SimpleParameterizedInlineMethod( object obj )
		{
			Console.WriteLine("Object is: {0}", obj.ToString());
		}

		[ForceInline]
		public static int ComplexParameterizedInlineMethod(object obj,int count)
		{
			if(obj is int)
			{
				Console.WriteLine("obj parameter is an int.");
				int o = (int)obj;
				count += 0;
			}
			else
			{
				Console.WriteLine("obj parameter is not an int.");
			}

			return 1 + count;
		}

		[ForceInline]
		public static Vector2 ReturnValueTypeMethod()
		{
			Vector2 v = new Vector2();

			v.X = 10;
			v.Y = 20;

			return v;
		}

		[ForceInline]
		public static Vector2 ComplexValueTypeMethod(Vector2 a,Vector2 b)
		{
			Vector2 c = new Vector2();

			c.X = a.X + b.X;
			c.Y = a.Y + b.Y;

			return c;
		}
	}
}