﻿#region MIT License
/*

Copyright (C) 2011 by Timothy A. Barela

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/
#endregion

using System;
using System.Drawing;
using Sharpener;

namespace TestExe
{
	public class TestClass
	{
		public static void Main()
		{
			Vector2 a = new Vector2();
			a.X = 1;

			Vector2 b = new Vector2();
			b.Y = 1;

			Vector2 c = InlineMethods.ComplexValueTypeMethod(a,b);

			Console.WriteLine("The value is {0}.",c.ToString());
		}

		public static void EndMain()
		{
			Console.WriteLine("Complete. Press enter.");
			Console.ReadLine();
		}

		public static void CallWith1Parameter( object o )
		{
			if(o != null)
				Console.WriteLine("Object is {0}", o.ToString());
			else
				Console.WriteLine("Object is null");
		}

		public static void CallWith2Parameters( object a, string b )
		{
			if(a != null)
				Console.WriteLine("Object is {0}", a.ToString());
			else
				Console.WriteLine("Object is null");

			Console.WriteLine("Message is {0}", b);
		}

		public static void BranchThenCall( DateTime dt )
		{
			string result = null;

			if(dt.CompareTo(DateTime.Now) > 0)
				result = "(dt is greater than Now)"; 
			else
				result = "(dt is not greater than Now.)";
						
			Console.WriteLine("The result is {0}", result );
		}

		public static void BranchThenCall2( DateTime dt )
		{
			string dtString = null;
			string result = null;

			dtString = dt.ToString();

			if(dt.CompareTo(DateTime.Now) > 0)
				result = "(dt is greater than Now)";
			else
				result = "(dt is not greater than Now.)";

			Console.WriteLine("{0} identified as {1}", dtString, result);
		}

		public static void ConditionalArgumentCall( DateTime dt )
		{
			string msg = "Arg = {0}";
			string arg;

			if(DateTime.Now > dt)
				arg = "true";
			else
				arg = "false";

			Console.WriteLine(msg, arg);
		}

		public static void ValueTypeParameter( Vector2 vec )
		{
			if(vec.X > 0)
				Console.WriteLine("Vector X == {0}.", vec.X);
		}
	}
}