﻿#region MIT License
/*

Copyright (C) 2011 by Timothy A. Barela

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/
#endregion

using System;
using Sharpener;

namespace TestExe
{
	public struct Vector2
	{
		public float X;
		public float Y;

		public Vector2( float x, float y )
		{
			X = x;
			Y = y;
		}

		public static Vector2 operator +( Vector2 a, Vector2 b )
		{
			float x = a.X + b.X;
			float y = a.Y + b.Y;
			return new Vector2(x, y);
		}

		public static Vector2 operator -( Vector2 a, Vector2 b )
		{
			float x = a.X - b.X;
			float y = a.Y - b.Y;
			return new Vector2(x, y);
		}

		public static Vector2 operator *( Vector2 vec, float scalar )
		{
			float x = vec.X * scalar;
			float y = vec.Y * scalar;
			return new Vector2(x, y);
		}

		public override string ToString()
		{
			return string.Format("({0},{1})",X,Y);
		}
	}
}